# Class QueryBoundWitnessBuilder<TBoundWitness, TQuery>

#### Type Parameters

- #### TBoundWitness extends QueryBoundWitness = QueryBoundWitness

- #### TQuery extends Query = Query

#### Hierarchy

- BoundWitnessBuilder<TBoundWitness>
  - QueryBoundWitnessBuilder

- Defined in modules/packages/module/packages/abstract/dist/types/Query/QueryBoundWitnessBuilder.d.ts:5

#####
Index

### Constructors

constructor

### Properties

_query
_resultSet
config
logger?

### Accessors

_payload_hashes
_payload_schemas

### Methods

build
hashableFields
hashes
payload
payloads
query
resultSet
signatures
witness
witnesses

## Constructors

### constructor

- new QueryBoundWitnessBuilder<TBoundWitness, TQuery>(config?, logger?): QueryBoundWitnessBuilder<TBoundWitness, TQuery>

- #### Type Parameters

  - #### TBoundWitness extends SchemaFields & PayloadFields & BoundWitnessFields & {
    query: string;
    resultSet?: string;
    schema: "network.xyo.boundwitness";
    } = SchemaFields & PayloadFields & BoundWitnessFields & {
    query: string;
    resultSet?: string;
    schema: "network.xyo.boundwitness";
    }

  - #### TQuery extends SchemaFields & PayloadFields & QueryFields & {
    schema: string;
    } = SchemaFields & PayloadFields & QueryFields & {
    schema: string;
    }

  #### Parameters

  - ##### `Optional` config: BoundWitnessBuilderConfig

  - ##### `Optional` logger: Logger

  #### Returns QueryBoundWitnessBuilder<TBoundWitness, TQuery>

  Inherited from BoundWitnessBuilder<TBoundWitness>.constructor

  - Defined in protocol/packages/boundwitness/packages/builder/dist/types/Builder.d.ts:21

## Properties

### `Private` _query

_query: any

- Defined in modules/packages/module/packages/abstract/dist/types/Query/QueryBoundWitnessBuilder.d.ts:6

### `Private` _resultSet

_resultSet: any

- Defined in modules/packages/module/packages/abstract/dist/types/Query/QueryBoundWitnessBuilder.d.ts:7

### `Readonly` config

config: BoundWitnessBuilderConfig

Inherited from BoundWitnessBuilder.config

- Defined in protocol/packages/boundwitness/packages/builder/dist/types/Builder.d.ts:14

### `Protected` `Optional` `Readonly` logger

logger?: Logger

Inherited from BoundWitnessBuilder.logger

- Defined in protocol/packages/boundwitness/packages/builder/dist/types/Builder.d.ts:15

## Accessors

### `Private` _payload_hashes

- get _payload_hashes(): any

- #### Returns any

  Inherited from BoundWitnessBuilder._payload_hashes

  - Defined in protocol/packages/boundwitness/packages/builder/dist/types/Builder.d.ts:22

### `Private` _payload_schemas

- get _payload_schemas(): any

- #### Returns any

  Inherited from BoundWitnessBuilder._payload_schemas

  - Defined in protocol/packages/boundwitness/packages/builder/dist/types/Builder.d.ts:23

## Methods

### build

- build(meta?): Promise<[TBoundWitness, (SchemaFields & PayloadFields & {
  schema: string;
  })[]]>

- #### Parameters

  - ##### `Optional` meta: boolean

  #### Returns Promise<[TBoundWitness, (SchemaFields & PayloadFields & {
  schema: string;
  })[]]>

  Inherited from BoundWitnessBuilder.build

  - Defined in protocol/packages/boundwitness/packages/builder/dist/types/Builder.d.ts:24

### hashableFields

- hashableFields(): TBoundWitness

- #### Returns TBoundWitness

  Overrides BoundWitnessBuilder.hashableFields

  - Defined in modules/packages/module/packages/abstract/dist/types/Query/QueryBoundWitnessBuilder.d.ts:8

### hashes

- hashes(hashes, schema): QueryBoundWitnessBuilder<TBoundWitness, TQuery>

- #### Parameters

  - ##### hashes: string[]

  - ##### schema: string[]

  #### Returns QueryBoundWitnessBuilder<TBoundWitness, TQuery>

  Inherited from BoundWitnessBuilder.hashes

  - Defined in protocol/packages/boundwitness/packages/builder/dist/types/Builder.d.ts:26

### payload

- payload(payload?): QueryBoundWitnessBuilder<TBoundWitness, TQuery>

- #### Parameters

  - ##### `Optional` payload: SchemaFields & PayloadFields & {
    schema: string;
    }

  #### Returns QueryBoundWitnessBuilder<TBoundWitness, TQuery>

  Inherited from BoundWitnessBuilder.payload

  - Defined in protocol/packages/boundwitness/packages/builder/dist/types/Builder.d.ts:27

### payloads

- payloads(payloads?): QueryBoundWitnessBuilder<TBoundWitness, TQuery>

- #### Parameters

  - ##### `Optional` payloads: (null | SchemaFields & PayloadFields & {
    schema: string;
    })[]

  #### Returns QueryBoundWitnessBuilder<TBoundWitness, TQuery>

  Inherited from BoundWitnessBuilder.payloads

  - Defined in protocol/packages/boundwitness/packages/builder/dist/types/Builder.d.ts:28

### query

- query<T>(query): QueryBoundWitnessBuilder<TBoundWitness, TQuery>

- #### Type Parameters

  - #### T extends SchemaFields & PayloadFields & QueryFields & {
    schema: string;
    } | PayloadWrapper<TQuery>

  #### Parameters

  - ##### query: T

  #### Returns QueryBoundWitnessBuilder<TBoundWitness, TQuery>

  - Defined in modules/packages/module/packages/abstract/dist/types/Query/QueryBoundWitnessBuilder.d.ts:9

### resultSet

- resultSet<T>(payloadSet): QueryBoundWitnessBuilder<TBoundWitness, TQuery>

- #### Type Parameters

  - #### T extends SchemaFields & PayloadFields & PayloadSet & {
    schema: "network.xyo.payload.set";
    } | PayloadWrapper<SchemaFields & PayloadFields & PayloadSet & {
    schema: "network.xyo.payload.set";
    }>

  #### Parameters

  - ##### payloadSet: T

  #### Returns QueryBoundWitnessBuilder<TBoundWitness, TQuery>

  - Defined in modules/packages/module/packages/abstract/dist/types/Query/QueryBoundWitnessBuilder.d.ts:10

### `Protected` signatures

- signatures(_hash): Promise<string[]>

- #### Parameters

  - ##### _hash: string

  #### Returns Promise<string[]>

  Inherited from BoundWitnessBuilder.signatures

  - Defined in protocol/packages/boundwitness/packages/builder/dist/types/Builder.d.ts:31

### witness

- witness(account): QueryBoundWitnessBuilder<TBoundWitness, TQuery>

- #### Parameters

  - ##### account: AccountInstance

  #### Returns QueryBoundWitnessBuilder<TBoundWitness, TQuery>

  Inherited from BoundWitnessBuilder.witness

  - Defined in protocol/packages/boundwitness/packages/builder/dist/types/Builder.d.ts:29

### witnesses

- witnesses(accounts): QueryBoundWitnessBuilder<TBoundWitness, TQuery>

- #### Parameters

  - ##### accounts: AccountInstance[]

  #### Returns QueryBoundWitnessBuilder<TBoundWitness, TQuery>

  Inherited from BoundWitnessBuilder.witnesses

  - Defined in protocol/packages/boundwitness/packages/builder/dist/types/Builder.d.ts:30

Generated using TypeDoc